<style>
  .tb td { padding: 2px 10px; border: solid 1px grey}
  .tb th { padding: 2px 10px; border: solid 2px grey; background-color: goldenrod; color:black; text-align: left; }
  tr > th { font-weight: bold }
  tr > td:last-of-type { font-style: italic; }
  tr > td:first-of-type { font-weight: bold }
  xparm {color: goldenrod; font-style: italic; vertical-align: sub; }
  xnote {border-bottom: grey solid; }
  .line { height: 2px; border-width: 0; color: grey; background-color: goldenrod;}

</style>

# Deployment for artifactory and the pipeline

Pipeline testing requires the use of a specially created artifactory image containing postgres and and a
copy of python configured with the testing requirements. 

<hr class="line">

## 1. Create the docker image for pipeline testing
The required image can be created with the `upload_image.sh` bash script 

1) Go to the repository's [test/functional](.) folder.
2) Execute `./upload_image.sh`
   1) If required, use your corporate LDAP username and password
3) Wait for the script to complete; check the information [HERE](https://artifactory-pub.bit9.local/ui/packages/docker:%2F%2Fenki%2Ftest?name=enki%2Ftest&packageType=docker&type=packages)
   to see if the build was pushed. 

> _**NOTE:** This script must be executed when python requirements or any core configuration changes have been made.
> It MUST be performed by someone on an AMD64 architecture device (for the pipeline use)._
 
## 2. Local Validation
Creation and use of the local image can be used to execute the functional tests without needing the local-infra.

1) In **ORIENT**, use the `+pipeline-image` function to locally build and deploy the testing image.  The process is complete when you see:
   ```text 
   PostgreSQL init process complete; ready for start up.
   
   2023-01-30 21:23:31.931 UTC [1] LOG:  starting PostgreSQL 14.6 (Debian 14.6-1.pgdg110+1) on aarch64-unknown-linux-gnu, compiled by gcc (Debian 10.2.1-6) 10.2.1 20210110, 64-bit
   2023-01-30 21:23:31.931 UTC [1] LOG:  listening on IPv4 address "0.0.0.0", port 5432
   2023-01-30 21:23:31.931 UTC [1] LOG:  listening on IPv6 address "::", port 5432
   2023-01-30 21:23:31.935 UTC [1] LOG:  listening on Unix socket "/var/run/postgresql/.s.PGSQL.5432"
   2023-01-30 21:23:31.940 UTC [61] LOG:  database system was shut down at 2023-01-30 21:23:31 UTC
   2023-01-30 21:23:31.946 UTC [1] LOG:  database system is ready to accept connections
   ```
   At this point, using `docker ps` should show your running container:
   ```text
   CONTAINER ID   IMAGE                                                           COMMAND                  CREATED         STATUS         PORTS      NAMES
   7204b31e7a4f   hinting-pytest                                                  "docker-entrypoint.s…"   7 minutes ago   Up 7 minutes   5432/tcp   epic_kirch
   ```
   If a container is already running when this function is called, it will be stopped before this new one is started.
2) The tests can be run within the image with the `+pipeline-test` function with no options.  There should be no failures
   ```text
   ================================================================== 71 passed, 2 deselected in 4.91s ===================================================================
   ```
   You can simply access the container with `+pipeline-test --shell`, which will allow you to examine any artifacts generated above
   (found in **./test/functional/suites/artifacts**).
3) When done with the image, it can be stopped with `+pipeline-kill`.

