#!/usr/bin/env bash
#
# Copyright (c) 2023 VMware Carbon Black, all rights reserved
#

# NOTE: Should only be run on an AMD64 system!

IMAGE_REPO=${IMAGE_REPO:-""}

docker login ${IMAGE_REPO}
IMAGE_TAG=SHA$(git rev-parse --short=8 HEAD)$(if ! git diff-index --quiet HEAD -- ; then echo "-dirty"; fi)
TEST_IMAGE=${IMAGE_REPO}/enki/hinting-functional-test

echo "Building image..."
docker build -f Dockerfile -t $TEST_IMAGE:$IMAGE_TAG .
if [ $? -ne 0 ]; then
    echo "*** Uanble to build the docker image -- aborting ***"
    exit 1
fi

echo "Pushing image to artifactory..."
docker image tag $TEST_IMAGE:$IMAGE_TAG $TEST_IMAGE:latest	

docker image push $TEST_IMAGE --all-tags 
