<style>
  .text { padding: 2px 10px 2px 10px; border: thin solid white; color: bisque; margin-left:25px;  width: fit-content}
  .line { height: 2px; border-width: 0; color: grey; background-color: goldenrod;}
</style>

# Python Utilities
This folder contains various python utilities that can be invoked on the command line when the ORIENT environment
is active.

<hr class="line">

## orgkey.py
When executed without any options, an orgkey is generated with an environment of "**enki**"
and a random orgid.
<pre class="text">
(HINT) hinting % orgkey.py

Generated OrgKey for ENV 'enki', OrgId '2179' ==> 2ZYCK6SLJFJWH4UELV
</pre>

With the `-e` option, you can create a key with a specifically chosen environment name and org id:
<pre class="text">
(HINT) hinting % orgkey.py -e myenv/12345       

Generated OrgKey for ENV 'myenv', OrgId '12345' ==> WW4AGKTLKB98S53H5UR9Z9
</pre>

The `-d` option can be used to decode any known orgkey into the original parts:
<pre class="text">
(HINT) hinting % orgkey.py -d WW4AGKTLKB98S53H5UR9Z9

OrgKey 'WW4AGKTLKB98S53H5UR9Z9' decoded ==> ENV 'myenv', OrgId '12345'
</pre>

## update_envfile.py
This utility executes `kubectl get secrets --namespace=local-apps -o yaml` to get the secrets and scrapes the output for the
postgres and redis passwords. It then reads an existing environment file (assumed to be `envfile` at the repositiory root, 
configurable with the `--path` option) and replaces the `PGPASSWORD` and `REDIS_AUTH_TOKEN` entries with the scraped 
values before writing out the the environment file again.
* Use the `--show` option to simply scrape and show the decoded passwords

<pre class="text">
PGPASSWORD:       28c7bac3ca8db12452ae961b1643dbd1199b853e182333a621785c615f57e882
REDIS_AUTH_TOKEN: 90fdf9833eca8ea26afc995efb1718789952a6b0885f9c00077627faa54fbbbc
</pre>