package test

import (
	"net/http"
	"net/http/httptest"

	"github.com/gin-gonic/gin"
	"gitlab.bit9.local/psckit/pscrbac"
)

func startRBACTestServer() *testRBACServer {
	ginRouter := gin.Default()
	server := httptest.NewServer(ginRouter)
	ginRouter.POST("/access/v1/demand", func(ctx *gin.Context) {
		ctx.JSON(http.StatusOK, pscrbac.DemandControlResponse{})
	})
	return &testRBACServer{httpServer: server, URL: server.URL}
}

type testRBACServer struct {
	httpServer *httptest.Server
	URL        string
}

func (s *testRBACServer) Close() {
	s.httpServer.Close()
}
